package util

import (
	"os"

	"gopkg.in/yaml.v2"
)

func NewConfig[V any](filepath string) (config *V, err error) {
	file, err := os.Open(filepath)
	if err != nil {
		return nil, err
	}
	defer file.Close()

	d := yaml.NewDecoder(file)

	if err := d.Decode(&config); err != nil {
		return nil, err
	}

	return config, nil
}
